%define base_name       el
%define short_name      commons-%{base_name}
%define name            jakarta-%{short_name}
%define section         free
%define servletversion	5.0.16

Name:           %{name}
Version:        1.0
Release:        2jpp_3fc
Epoch:          0
Summary:        The Jakarta Commons Extension Language
License:        Apache Software License
Group:          Development/Libraries/Java
URL:            http://jakarta.apache.org/commons/el/
Source0:        http://archive.apache.org/dist/jakarta/commons/el/source/commons-el-%{version}-src.tar.gz
Source1:	jakarta-servletapi-5-src.tar.gz
Patch0:		%{short_name}-%{version}-license.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot
BuildRequires:  ant, junit
BuildRequires:  jpackage-utils >= 0:1.5.30
BuildRequires:  servletapi5, log4j
# libgcj aot-compiled native libraries
BuildRequires:         gcc-java >= 4.0.0-0.43
BuildRequires:         java-1.4.2-gcj-compat >= 1.4.2.0-40jpp_16rh
Requires(post,postun): java-1.4.2-gcj-compat >= 1.4.2.0-40jpp_16rh
ExclusiveArch:         %{ix86} x86_64 ppc alpha

%description
An implementation of standard interfaces and abstract classes for
javax.servlet.jsp.el which is part of the JSP 2.0 specification.


%package        javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation
BuildRequires:  java-javadoc

%description    javadoc
Javadoc for %{name}.


%prep
%setup -q -n %{short_name}-%{version}-src
%patch0 -p1 -b .license

# unpack the servletapi stuff which api.home is depending on
gzip -dc %{SOURCE1} | tar xf - 

# fix license
cp jakarta-tomcat-%{servletversion}-src/src/jakarta-servletapi-5/jsr154/LICENSE .

# remove all precompiled stuff
find . -type f -name "*.jar" -exec rm -f {} \;

cat > build.properties <<EOBP
build.compiler=modern
api.home=$RPM_BUILD_DIR/%{short_name}-%{version}-src/jakarta-tomcat-%{servletversion}-src/src/jakarta-servletapi-5
junit.jar=$(build-classpath junit)
servlet-api.jar=$(build-classpath servletapi5)
jsp-api.jar=$(build-classpath jspapi)
servletapi.build.notrequired=true
jspapi.build.notrequired=true
EOBP

%build
ant \
  -Dfinal.name=%{short_name} \
  -Dj2se.javadoc=%{_javadocdir}/java \
  jar javadoc

aot-compile \
    dist/%{short_name}.jar \
    lib%{name}-%{version}.jar.so \
    "$RPM_OPT_FLAGS -fPIC"


%install
rm -rf $RPM_BUILD_ROOT

# jars
mkdir -p $RPM_BUILD_ROOT%{_javadir}
cp -p dist/%{short_name}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed "s|jakarta-||g"`; done)
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)

# javadoc
mkdir -p $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr dist/docs/api/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

# solibs
install -d -m 755 $RPM_BUILD_ROOT%{_libdir}
install -m 755 lib%{name}-%{version}.jar.so $RPM_BUILD_ROOT%{_libdir}
ln -sf lib%{name}-%{version}.jar.so $RPM_BUILD_ROOT%{_libdir}/lib%{name}.jar.so

# gcjdb
gcjdbdir=`gcj-dbtool -p %{_libdir}`.d
mkdir -p $RPM_BUILD_ROOT$gcjdbdir
gcj-dbtool -n $RPM_BUILD_ROOT$gcjdbdir/%{name}-%{version}.db 80000
gcj-dbtool -f $RPM_BUILD_ROOT$gcjdbdir/%{name}-%{version}.db \
  $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar \
  %{_libdir}/lib%{name}-%{version}.jar.so


%clean
rm -rf $RPM_BUILD_ROOT


%post
/usr/bin/rebuild-gcj-db %{_libdir}

%postun
/usr/bin/rebuild-gcj-db %{_libdir}

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}


%files
%defattr(0644,root,root,0755)
%doc LICENSE.txt STATUS.html
%{_javadir}/*
%attr(0755,root,root) %{_libdir}/lib*.jar.so
%{_libdir}/*/*/%{name}-%{version}.db

%files javadoc
%defattr(0644,root,root,0755)
%doc %{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}


%changelog
* Mon May 23 2005 Gary Benson <gbenson@redhat.com> - 0:1.0-2jpp_3fc
- Add alpha to the list of build architectures (#157522).
- Use absolute paths for rebuild-gcj-db.

* Thu May  5 2005 Gary Benson <gbenson@redhat.com> - 0:1.0-2jpp_2fc
- BC-compile.

* Thu Jan 20 2005 Gary Benson <gbenson@redhat.com> - 0:1.0-2jpp_1fc
- Build into Fedora.

* Thu Oct 21 2004 Fernando Nasser <fnasser@redhat.com> - 0:1.0-2jpp_2rh
- Rebuild (no changes)

* Wed Jul 14 2004 Fernando Nasser <fnasser@redhat.com> - 0:1.0-2jpp_1rh
- Merge with upstream version that removes dependency on ant-optional

* Tue Jun 01 2004 Randy Watler <rwatler at finali.com> - 0:1.0-2jpp
- Upgrade to Ant 1.6.X

* Fri Jan  9 2004 Kaj J. Niemi <kajtzu@fi.basen.net> - 0:1.0-1jpp
- First build for JPackage

* Wed Dec 17 2003 Kaj J. Niemi <kajtzu@fi.basen.net> - 0:1.0-0.2
- With Javadocs

* Wed Dec 17 2003 Kaj J. Niemi <kajtzu@fi.basen.net> - 0:1.0-0.1
- First build

